QGIS Application - Bug report #14532
Dissolve and Spatial Query doesn't work
2016-03-19 09:19 AM - Federico Gianoli

Status: Closed

Priority: Normal

Assignee:

Category: Processing/QGIS

Affected QGIS version:2.14.0 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 22505
Description

Hi!

| have a problem with the Dissolve tool and Spatial query.

I have a multipart polygon, created using dissolve tool, and a shp of points.
If | use "spatial query" and ask how many points are contained in these polygons, the results is 0, but this is not true.

The reference system is the same for all the layers (EPSG: 3003).

| have attached 3 shp:

-Centroidi (points layer)

-VenetoreclassOK (the source polygon layer)

-DissolveDN (the results of the Dissolve by the field DN)

Let's try another way to describe better the problem.

If | select, in the shp named DissolveDN, the DN categories 3 and 4, and than, using Spatial Query, | ask how many points are within the
categories 3 and 4, the results is 0. By the way if | did the same spatial query selecting categories 1 or 2, the tool works.

Really | don't understand why.

Please help me to figure out this issue. | have tryed with QGIS 2.14 and 2.8.7.

thanks a lot

Federico

History

#1 - 2016-03-19 01:25 PM - Anita Graser

Please attach the files you mentioned.

#2 - 2016-03-19 01:46 PM - Federico Gianoli
- File problems.rar added

I'm sorry, here the files.
Thanks

Federico

#3 - 2016-03-20 02:08 AM - Anita Graser

The dissolved layer has tons of problems, while the original layer is completely fine. That's what most likely throws off the spatial query tool. Did you use
dissolve from the vector menu (ftools) or from Processing?
message

ring 359 of palygon 0 notin exterior ring

polygon 483 inside polygon 0

polygon 487 inside polygon 0

ring 93 of polygon 0 not in exteriar ring

palygon 2 inside palygon 1

palygon 3 inside palygon 1

palygon 5 inside palygon 4

palygon & inside palygon 4

polygon & inside palygon 7

polygon 9 inside palygon 7

11 polygon 33 inside polygon 32

polygon 55 inside polygon 54

= palygon 64 inside polygon 63

- palygon 29 inside polygon 1

[ T Show All Features _

#4 - 2016-03-20 02:09 AM - Anita Graser
- File dissolve_errors.png added

#5 - 2016-03-20 02:29 AM - Anita Graser

- Category set to Processing/QGIS

I now tried three dissolve algorithms in the Processing toolbox:

- QGIS Dissolve: The result didn't even contain all input features

- SAGE Dissolve: Looked ok but Spatial Query didn't select any centroids as "within"
- GRASS Dissolve: This worked! Spatial Query selected 590 out of 591 as "within" (one is slightly outside of the polygons)
#6 - 2016-03-20 08:45 AM - Federico Gianoli

Thanks Anita,

| used Dissolve from processing toolbox.
s0, in order to have a right multipart polygon, | have to use the GRASS tool?

In your opinion, why the dissolve tool doesn't work correctly?

Thanks a lot for your test.

Federico

#7 - 2016-03-20 11:05 AM - Maximilian Krambach

As to why QGIS Dissolve leaves out output: GEOS:combine (which is used by QGIS:dissolve) returns eight geometry errors, and in the output eight
polygons are missing. | guess that QGIS:dissolve only writes "correct” geometries as output. Those "defect" geometries are cases where an inner ring

touches the outer ring.

#8 - 2016-03-20 11:21 AM - Anita Graser

| guess the main issue with QGIS:dissolve's behavior is that there are zero warnings in the tool log or the QGIS message log. Instead, it just silently drops

the features ...

#9 - 2016-03-20 11:27 AM - Maximilian Krambach

If I edit out the validity checks in dissolve.py , the polygon is dissolved just fine. Maybe dissolve should check for validity on the input, not the output

#10 - 2016-03-23 07:52 AM - Maximilian Krambach
- Status changed from Open to Closed

QGIS Dissolve fixed in master (commit:bec849c). Includes warnings to processing log, works with spatial query and does not drop valid geometries.

Files
problems.rar 467 KB 2016-03-19 Federico Gianoli
dissolve_errors.png 34.3 KB 2016-03-20 Anita Graser
https://github.com/qgis/QGIS/blob/99e21a7e5bd45a8612640a1c2ff0133a972e86ba/python/plugins/processing/algs/qgis/Dissolve.py

